#ifndef __OSDIEXT_H_DEFINED
#define __OSDIEXT_H_DEFINED

#include "ifsim.h"
#include <stdio.h>

int osdiLoadModels(const char *file, const char *path, const int debug);
void osdiListModels(FILE *f);
int isOsdiDevice(int devType);
int osdiTerminalCount(int devType); 
int osdiGetTerminal(GENERIC *instPtr, int terminal);
int osdiBindTerminal(GENERIC *instPtr, int terminalIndex, GENERIC *node); 
int osdiUnbindTerminal(GENERIC *instPtr, int terminalIndex);
void osdiDeviceBoundStep(int devType, GENERIC *inst, double *timestep); 
int osdiNodeCount(int devType);
const char *osdiNodeName(int devType, int i);
int osdiIsFlowNode(int devType, int i);
int osdiCollapsibleCount(int devType); 
void osdiCollapsiblePair(int devType, int i, char **node1, char **node2);

#endif
